---
title: HTMLTableCellElement
slug: Web/API/HTMLTableCellElement
tags:
  - API
  - Cells
  - HTML DOM
  - HTMLTableCellElement
  - Interface
  - Reference
  - Table Cells
  - Tables
---
<div>
<div>{{ APIRef("HTML DOM") }}</div>
</div>

<p>The <strong><code>HTMLTableCellElement</code></strong> interface provides special properties and methods (beyond the regular {{domxref("HTMLElement")}} interface it also has available to it by inheritance) for manipulating the layout and presentation of table cells, either header or data cells, in an HTML document.</p>

<p>{{InheritanceDiagram(600, 120)}}</p>

<h2 id="Properties">Properties</h2>

<p><em>Inherits properties from its parent, {{domxref("HTMLElement")}}.</em></p>

<dl>
 <dt>{{domxref("HTMLTableCellElement.abbr")}}</dt>
 <dd>A {{domxref("DOMString")}} which can be used on <code>&lt;th&gt;</code> elements (not on {{HTMLElement("td")}}), specifying an alternative label for the header cell. This alternate label can be used in other contexts, such as when describing the headers that apply to a data cell. This is used to offer a shorter term for use by screen readers in particular, and is a valuable accessibility tool. Usually the value of <code>abbr</code> is an abbreviation or acronym, but can be any text that's appropriate contextually.</dd>
 <dt>{{domxref("HTMLTableCellElement.cellIndex")}} {{readonlyInline}}</dt>
 <dd>A long integer representing the cell's position in the {{domxref("HTMLTableRowElement.cells", "cells")}} collection of the {{HTMLElement("tr")}} the cell is contained within. If the cell doesn't belong to a <code>&lt;tr&gt;</code>, it returns <code>-1</code>.</dd>
 <dt>{{domxref("HTMLTableCellElement.colSpan")}}</dt>
 <dd>An unsigned long integer indicating the number of columns this cell must span; this lets the cell occupy space across multiple columns of the table. It reflects the {{htmlattrxref("colspan", "td")}} attribute.</dd>
 <dt>{{domxref("HTMLTableCellElement.headers")}} {{readonlyInline}}</dt>
 <dd>Is a {{domxref("DOMSettableTokenList")}} describing a list of <code>id</code> of {{HTMLElement("th")}} elements that represents headers associated with the cell. It reflects the {{htmlattrxref("headers", "td")}} attribute.</dd>
 <dt>{{domxref("HTMLTableCellElement.rowSpan")}}</dt>
 <dd>An unsigned long integer indicating the number of rows this cell must span; this lets a cell occupy space across multiple rows of the table. It reflects the {{htmlattrxref("rowspan", "td")}} attribute.</dd>
 <dt>{{domxref("HTMLTableCellElement.scope")}}</dt>
 <dd>A {{domxref("DOMString")}} indicating the scope of a {{HTMLElement("th")}} cell. Header cells can be configured, using the <code>scope</code> property, the apply to a specified row or column, or to the not-yet-scoped cells within the current row group (that is, the same ancestor {{HTMLElement("thead")}}, {{HTMLElement("tbody")}}, or {{HTMLElement("tfoot")}} element). If no value is specified for <code>scope</code>, the header is not associated directly with cells in this way. Permitted values for <code>scope</code> are:
 <dl>
  <dt><code>col</code></dt>
  <dd>The header cell applies to the following cells in the same column (or columns, if <code>colspan</code> is used as well), until either the end of the column or another <code>&lt;th&gt;</code> in the column establishes a new scope.</dd>
  <dt><code>colgroup</code></dt>
  <dd>The header cell applies to all cells in the current column group that do not already have a scope applied to them. This value is only allowed if the cell is in a column group.</dd>
  <dt><code>row</code></dt>
  <dd>The header cell applies to the following cells in the same row (or rows, if <code>rowspan</code> is used as well), until either the end of the row or another <code>&lt;th&gt;</code> in the same row establishes a new scope.</dd>
  <dt><code>rowgroup</code></dt>
  <dd>The header cell applies to all cells in the current row group that do not already have a scope applied to them. This value is only allowed if the cell is in a row group.</dd>
  <dt>The empty string (<code>""</code>)</dt>
  <dd>The header cell has no predefined scope; the user agent will establish the scope based on contextual clues.</dd>
 </dl>
 </dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>No specific method; inherits methods from its parent, {{domxref("HTMLElement")}}</em>.</p>

<h2 id="Deprecated_properties">Deprecated properties</h2>

<div class="notecard warning">
<p><strong>Warning:</strong> These properties have been {{Glossary("deprecated")}} and should no longer be used. They are documented primarily to help understand older code bases.</p>
</div>

<details>
<dl>
 <dt>{{domxref("HTMLTableCellElement.align")}} {{obsolete_inline}}</dt>
 <dd>A {{domxref("DOMString")}} containing an enumerated value reflecting the {{htmlattrxref("align", "td")}} attribute. It indicates the alignment of the element's contents with respect to the surrounding context. The possible values are <code>"left"</code>, <code>"right"</code>, and <code>"center"</code>.</dd>
 <dt>{{domxref("HTMLTableCellElement.axis")}} {{obsolete_inline}}</dt>
 <dd>A {{domxref("DOMString")}} containing a name grouping cells in virtual. It reflects the obsolete {{htmlattrxref("axis", "td")}} attribute.</dd>
 <dt>{{domxref("HTMLTableCellElement.bgColor")}} {{obsolete_inline}}</dt>
 <dd>A {{domxref("DOMString")}} containing the background color of the cells. It reflects the obsolete {{htmlattrxref("bgColor", "td")}} attribute.</dd>
 <dt>{{domxref("HTMLTableCellElement.ch")}} {{obsolete_inline}}</dt>
 <dd>A {{domxref("DOMString")}} containing one single chararcter. This character is the one to align all the cell of a column on. It reflects the {{htmlattrxref("char", "td")}} and default to the decimal points associated with the language, e.g. <code>'.'</code> for English, or <code>','</code> for French. This property was optional and was not very well supported.</dd>
 <dt>{{domxref("HTMLTableCellElement.chOff")}} {{obsolete_inline}}</dt>
 <dd>A {{domxref("DOMString")}} containing a integer indicating how many characters must be left at the right (for left-to-right scripts; or at the left for right-to-left scripts) of the character defined by <code>HTMLTableCellElement.ch</code>. This property was optional and was not very well supported.</dd>
 <dt>{{domxref("HTMLTableCellElement.height")}} {{obsolete_inline}}</dt>
 <dd>A {{domxref("DOMString")}} containing a length of pixel of the hinted height of the cell. It reflects the obsolete {{htmlattrxref("height", "td")}} attribute.</dd>
 <dt>{{domxref("HTMLTableCellElement.noWrap")}} {{obsolete_inline}}</dt>
 <dd>A {{domxref("Boolean")}} value reflecting the {{htmlattrxref("nowrap", "td")}} attribute and indicating if cell content can be broken in several lines.</dd>
 <dt>{{domxref("HTMLTableCellElement.vAlign")}} {{obsolete_inline}}</dt>
 <dd>A {{domxref("DOMString")}} representing an enumerated value indicating how the content of the cell must be vertically aligned. It reflects the {{htmlattrxref("valign", "td")}} attribute and can have one of the following values: <code>"top"</code>, <code>"middle"</code>, <code>"bottom"</code>, or <code>"baseline"</code>. Use the CSS {{cssxref("vertical-align")}} property instead.</dd>
 <dt>{{domxref("HTMLTableCellElement.width")}} {{obsolete_inline}}</dt>
 <dd>A {{domxref("DOMString")}} specifying the number of pixels wide the cell should be drawn, if possible. This property reflects the also obsolete {{htmlattrxref("width", "td")}} attribute. Use the CSS {{cssxref("width")}} property instead.</dd>
</dl>
</details>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', "tabular-data.html#htmltablecellelement", "HTMLTableCellElement")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>No change from {{SpecName("HTML5 W3C")}}.</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', "tabular-data.html#htmltablecellelement", "HTMLTableCellElement")}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td>The following properties have been obsoleted: <code>align</code>, <code>axis</code>, <code>bgColor</code>, <code>height</code>, <code>width</code>, <code>ch</code>, <code>chOff</code>, <code>noWrap</code>, and <code>vAlign</code>.<br>
    The <code>headers</code> property is now read-only and contains a {{domxref("DOMSettableTokenList")}} rather than a mere {{domxref("DOMString")}}.<br>
    The <code>colspan</code> and <code>rowspan</code> properties are now <code>unsigned long</code>.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 HTML', 'html.html#ID-82915075', 'HTMLTableCellElement')}}</td>
   <td>{{Spec2('DOM2 HTML')}}</td>
   <td>The <code>cellIndex</code> property is now read-only.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM1', 'level-one-html.html#ID-82915075', 'HTMLTableCellElement')}}</td>
   <td>{{Spec2('DOM1')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.HTMLTableCellElement")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>The HTML elements implementing this interface: {{HTMLElement("th")}} and {{HTMLElement("td")}} by inheritance via {{domxref("HTMLTableHeaderCellElement")}} {{obsolete_inline}} and {{domxref("HTMLTableDataCellElement")}} {{obsolete_inline}}.</li>
</ul>
